"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const camelize_1 = require("./utils/camelize");
const methods_1 = require("./utils/methods");
function flattenParse(data, extractedIncluded) {
    if (Array.isArray(data)) {
        const extractedData = data.reduce((result, resource) => {
            const { id, type } = resource;
            const datumn = methods_1.extractData(resource);
            const camelizedType = camelize_1.camelize(type);
            if (result[camelizedType]) {
                result[camelizedType][id] = datumn;
            }
            else {
                result[camelizedType] = {
                    [id]: datumn,
                };
            }
            return result;
        }, {});
        return Object.assign(Object.assign({}, extractedData), extractedIncluded);
    }
    return Object.assign({ [camelize_1.camelize(data.type)]: methods_1.extractData(data, 'flatten') }, extractedIncluded);
}
const mapRelation = (data, extractedIncluded) => {
    return Object.entries(data).reduce((result, [k, v]) => {
        var _a;
        if (!v) {
            return result;
        }
        let relationData;
        if (Array.isArray(v)) {
            relationData = v.reduce((result, datumn) => {
                var _a;
                const { id, type } = datumn;
                const camelizedType = camelize_1.camelize(type);
                const extractedIncludedData = (_a = extractedIncluded[camelizedType]) === null || _a === void 0 ? void 0 : _a[id];
                if (!extractedIncludedData) {
                    return result;
                }
                const { relationships } = extractedIncludedData, relation = __rest(extractedIncludedData, ["relationships"]);
                result.push(Object.assign(Object.assign({}, relation), mapRelation(relationships, extractedIncluded)));
                return result;
            }, []);
        }
        else {
            const { id, type } = v;
            const camelizedType = camelize_1.camelize(type);
            const extractedIncludedData = (_a = extractedIncluded[camelizedType]) === null || _a === void 0 ? void 0 : _a[id];
            if (!extractedIncludedData) {
                return result;
            }
            const { relationships } = extractedIncludedData, relation = __rest(extractedIncludedData, ["relationships"]);
            relationData = Object.assign(Object.assign({}, relation), mapRelation(relationships, extractedIncluded));
        }
        Object.assign(result, {
            [camelize_1.camelize(k)]: relationData,
        });
        return result;
    }, {});
};
function mappingParse(data, extractedIncluded) {
    if (Array.isArray(data)) {
        return data.map((resource) => {
            const _a = methods_1.extractData(resource, 'mapping'), { relationships } = _a, datumn = __rest(_a, ["relationships"]);
            return Object.assign(Object.assign({}, datumn), mapRelation(relationships, extractedIncluded));
        });
    }
    const _a = methods_1.extractData(data, 'mapping'), { relationships } = _a, datumn = __rest(_a, ["relationships"]);
    return Object.assign(Object.assign({}, datumn), mapRelation(relationships, extractedIncluded));
}
const methods = {
    flatten: flattenParse,
    mapping: mappingParse,
};
function parseJsonApi({ data, included, }, opts = {}) {
    const { mode = 'flatten' } = opts;
    const extractedIncluded = methods_1.extractIncluded(included, mode);
    return methods[mode](data, extractedIncluded);
}
exports.default = parseJsonApi;
